// HmJre.dll copyright(c) 2003 LЃTCg[
// written by ēGv
// QlURL  http://www.labyrinth.net.au/~dbareis/3rdpsrc.htm#HENRY_SPENCER_REGEXP_SOURCE

#ifndef JREFUZZY
#define JREFUZZY

// JreFuzzy.h
#define FUZZYOPTION_NOCASE				1		// pp̑啶^ʂȂ
//p~#define FUZZYOPTION_NOCASEZENKAKU		2		// Spp̑啶^ʂȂ
#define FUZZYOPTION_NOHANZEN			4		// p^SpʂȂ
#define FUZZYOPTION_NOHIRAKATA			8		// Ђ炪ȂƃJ^JiʂȂ
#define FUZZYOPTION_NOBIGSMALLKANA		0x10	// 傫uvƏuvʂȂ
#define FUZZYOPTION_NODAKUON			0x20	// AʂȂBúvAu΁vAuρv𓯈ꎋB
#define FUZZYOPTION_KANAHYPHEN			0x40	// Ȃ́u[vƉṕu|v𓯈ꎋ
#define FUZZYOPTION_NOSPACE				0x80	// 󔒁^^u𖳎
#define FUZZYOPTION_NORETURN			0x100	// s𖳎
#define FUZZYOPTION_CUSTOMIGNORE		0x200	// 蕶𖳎BV1.09B

#define FUZZYOPTION_CUSTOM1			0x00010000
#define FUZZYOPTION_CUSTOM2			0x00020000
#define FUZZYOPTION_CUSTOM3			0x00040000
#define FUZZYOPTION_CUSTOM4			0x00080000

#define FUZZYOPTION_NORETURN_MASK		0x70000000	// 0`7 --> 1`8ɑΉB
#define FUZZYOPTION_NORETURN_SHIFT		28			// 28rbgVtgB


#define FUZZYOPTION_ALL			0xFFFFFFFF

struct JREFUZZYDATA {
	DWORD	dwSize;
	DWORD	flags;
	char*	pszFindConved;
	int		cchFindConved;
	char*	pszTargetConved;
	int		cchTargetConved;
	short*	psTargetPos;
	WORD*	pwCustomConv;
	char*	pszTargetOrigin;	// ϊOpszTargetAV0.04B
	char*	pbSynonym;
	int		cbSynonym;
	int		cSynonymMultiplyMax;
	int		cchSynonymWordMax;
	int		cbFindConvedAlloc;			//V0.06B
	int		cbTargetConvedAlloc;		//V0.06B
	DWORD	adwReserve[6];
};

extern "C" BOOL WINAPI Fuzzy_Open( JREFUZZYDATA* pData, BOOL fDummy = FALSE );
extern "C" BOOL WINAPI Fuzzy_Close( JREFUZZYDATA* pData );
extern "C" BOOL WINAPI Fuzzy_ConvertTarget( JREFUZZYDATA* pData, const char* pszSrc );
extern "C" BOOL WINAPI Fuzzy_ConvertFindString( JREFUZZYDATA* pData, const char* pszSrc, BOOL fRegular );
extern "C" int WINAPI Fuzzy_FindPos2RealPos( JREFUZZYDATA* pData, int x );
extern "C" int WINAPI Fuzzy_FindArea2RealArea( JREFUZZYDATA* pData, int x, int* pcchMatch );
extern "C" int WINAPI Fuzzy_RealPos2FindPos( JREFUZZYDATA* pData, int x );
extern "C" JREFUZZYDATA* WINAPI Fuzzy_GetFuzzyDataInJre( JRE2* pJre );
extern "C" BOOL _cdecl Fuzzy_OptionDialog( HWND hwndParent, UINT flagsDisable );

#define FUZZYERROR_FINDSTRING_NOTHING		100

#endif
