#ifndef	__COMFILE_H
#define	__COMFILE_H

#include "tndefs.h"
#include "tnstr.h"

// GetxxxxFilename DialogBox IDs
#define	IDGF_FILENAME		1152	// Edit box
#define	IDGF_FILENAMEEX		1148	// ComBox
#define	IDGF_FILEBOX		1120
#define	IDGF_DIRBOX			1121
#define	IDGF_DIRECTORY		1088
#define	IDGF_FILETYPETITLE	1089
#define	IDGF_FILETYPE		1136
#define	IDGF_DRIVETITLE		1091
#define	IDGF_DRIVE			1137
#define	IDGF_READONLY		1040

struct FilterListStruct {
	tchar *name;
	tchar *pattern;
};

// IɁAofn.FlagsɃZbgtO
//	OFN_NOREADONLYRETURN	: It@Cǂݎp̃t@CłȂ

//	R_CAO{bNXNX
class CommFileDialog {
public:
	OPENFILENAME ofn;
protected:
	tnstr &pathname;
	tnstr filterbuffer;
	tchar *pathbuffer;
#ifndef WINCE
	UINT (CALLBACK *lpfnHook)(HWND, UINT, WPARAM, LPARAM);
#endif
public:
	CommFileDialog( HWND hwnd, tnstr &path, LPCTSTR title=NULL );
		// EnableDragDrop()gꍇ́AȂ炸hwndKv(hInstancê)
	virtual ~CommFileDialog();
	virtual void Initialize( );		// ftHg̐ݒɖ߂
	virtual bool Execute( ) = 0;		// sJn
							// sÃNX͎Iɍ폜Ȃ̂ŒӁI

	//////////////////////////////////////
	//	tOɊւݒ				//
	//////////////////////////////////////

	// tO̒ڂ̃Zbg
	void SetFlags( DWORD flag )
		{ ofn.Flags |= flag; }
	void ResetFlags( DWORD flag )
		{ ofn.Flags &= ~flag; }

#ifndef WINCE
	// }`t@CZNg
	// I擾Fc:\files file1.txt file2.txt ..\bin\file3.txt
	//		EfBNgƃt@C͕ʁX
	//		E΃pXL蓾
	//		E؂蕶' '
	void AllowMultiSelect( int size );	// size̓obt@[̃TCY
#endif

	// t@C݂ĂȂƂȂipX͂̎j
	//	ECommFileOpenDialogNXł̓ftHgŐݒς
	void FileMustExist( )
		{ ofn.Flags |= OFN_FILEMUSTEXIST; }
	// pX݂ĂȂƂȂ
	void PathMustExist( )
		{ ofn.Flags |= OFN_PATHMUSTEXIST; }

	// ǂݎp`FbN{bNXLɂiftHgł͕\Ȃj
	void EnableReadOnly( )
		{ ofn.Flags &= ~OFN_HIDEREADONLY; }
#ifndef WINCE	// Microsoft̊ԈႢH`ĂȂEEE
	// ǂݎp`FbN{bNX`FbNɂ
	void CheckReadOnly( )
		{ ofn.Flags |= OFN_READONLY; }
#endif

	// t@C݂ȂƂAVKł鎖mF\
	void CreatePrompt( )
		{ ofn.Flags |= OFN_CREATEPROMPT; }

	// [Otĕۑ]ŁAłɃt@C݂ĂꍇmF
	//	ECommFileSaveDialogNXł̓ftHgŐݒς
	void OverWritePrompt( )
		{ ofn.Flags |= OFN_OVERWRITEPROMPT; }

	// JgfBNg_CAO쐬̃fBNgɋIɕύXA
	// IƁÃfBNgɖ߂B
	// igȂj
	void NoChangeDir( )
		{ ofn.Flags |= OFN_NOCHANGEDIR; }

	//////////////////////////////////////
	//	t@CɊւݒ			//
	//////////////////////////////////////

	// ftHg̊gq̐ݒ('.'͊܂߂Ȃj
	void SetDefExtension( const tchar *str )
		{ ofn.lpstrDefExt = (tchar*)str; }

	// _CAO{bNXIɁApXt@C擾Ƃ
	void SetFileTitleBuffer( LPTSTR buf, int len )
		{
			ofn.lpstrFileTitle = buf;
			ofn.nMaxFileTitle = len;
		}

	// ̃fBNg̎wiRXgN^œnpathpXDIj
	void SetInitialDir( LPCTSTR str )
		{ ofn.lpstrInitialDir = (LPTSTR)str; }

	//////////////////////////////////////////
	//	tB^[Ɋւݒ				//
	//////////////////////////////////////////

	// tB^[̃Zbg
	// \̂ɂw(FilterListStruct̂PzŎwj
	// z̍ŌnameNULLɂ鎖
	void SetFilter( struct FilterListStruct *filterlist );
	// W@ɂw
	//	chDeliḿAfilterlist̃Xg̋؂蕶w
	// FSetFilter( "ş(*.exe)|*.exe|S(*.*)|*.*|", '|' );
	void SetFilter( LPCTSTR filterlist, tchar chDelim=NULL );

	// ̃tB^[̃CfbNXԍ̎w
	void SetFilterIndex( int i )
		{ ofn.nFilterIndex = i+1; }	// 0n܂鎖ɒ

	// ̃tB^[AyяIɂfilterɍŌɑIĂtB^[Zbg
	// len40ȏł鎖
	// ̊֐ŃZbgASetFilterIndexsƁÃtB^[ƂėpȂ̂ŒӁII
	// ڂSDKwvQ
	void SetCustomFilter( LPTSTR filter, int len );

	//////////////////////////////////////////
	//	[UC^[tF[XɊւݒ	//
	//////////////////////////////////////////

	tnstr helpname;
	UINT helpcommand;
	DWORD helpdata;
	void UseHelp( const tchar *helpname, UINT command, DWORD data );		// Helpgpꍇ

#ifndef WINCE
	// ev[ggpꍇ
	void SetTemplate( LPCTSTR lpTemplateName );
	void SetTemplate( HINSTANCE hInstance );
#endif

public:
	WORD HookFlags;		// EnableDragDrop()ptO
#define	CHK_DRAGDROP	0x002
public:
#ifndef WINCE
	// tbN֐
	// VɃtbN֐AeNXCommFileOpenHook()ĂԂ
	// lCustData̓ftHgłthisZbĝŁAftHĝ܂܂ɂĂ
	// AǂĂʂȗprŗpꍇ́AEnableDragDrop()gȂ悤ɂ
	// XEnableDragDrop()pĂɁAlCustDatathisȊOɂꍇ
	// eNXCommFileOpenHook()Ă΂ɓƎɃtbN֐pӂKv
	void SetHook( UINT (CALLBACK *lpfnHook)(HWND, UINT, WPARAM, LPARAM), LPARAM lCustData=NULL );
	// UINT (CALLBACK *lpfnHook)(HWND, UINT, WPARAM, LPARAM)

	// tbN֐Zbg
	void EnableDragDrop( );		// hbOhbvɂt@C󂯕t
#endif
protected:
	static UINT DllExport CALLBACK CommFileDialog::CommFileDialogHook(HWND hwnd, UINT wm, WPARAM wParam , LPARAM lParam );

private:
	void SetHookInternal( );
public:
	//////////////////////////////////////////
	//	IɎ擾\Ȋ֐				//
	//////////////////////////////////////////

	// t@C̃ItZbg𓾂
	int GetFileOffset( )
		{ return ofn.nFileOffset; }

	// gq܂ł̃ItZbg𓾂i'.'̎j
	//	EgqȂꍇ͏I['\0'̃ItZbgԂ
	//	Et@C̍Ōオ'.'ŊgqȂꍇ́A0Ԃ̂ŒӁII
	int GetExtensionOffset( )
		{ return ofn.nFileExtension; }

	// SetDefExtensionŐݒ肵ĂꍇA
	// ͂ꂽgqقȂĂƂTRUEԂ
	bool IsExtensionDifferent( )
		{ return ( ofn.Flags & OFN_EXTENSIONDIFFERENT ) == OFN_EXTENSIONDIFFERENT; }

	DWORD GetErrorCode( )
		{ return CommDlgExtendedError( ); }

};

// t@CI[vpR_CAO{bNXNX
class CommFileOpenDialog : public CommFileDialog {
public:
	CommFileOpenDialog( HWND hwnd, tnstr &path, LPCTSTR title=NULL );
	virtual void Initialize( );		// ftHg̐ݒɖ߂
	virtual bool Execute( );		// sJn
};

// t@CZ[upR_CAO{bNXNX
class CommFileSaveDialog : public CommFileDialog {
protected:
//	bool AppendExt;	// gqȂꍇFilterIndexɎgqǉ
public:
	CommFileSaveDialog( HWND hwnd, tnstr &path, LPCTSTR title=NULL );
//	void SetAppendExt(bool enabled)
//		{ AppendExt = enabled; }
	virtual void Initialize( );		// ftHg̐ݒɖ߂
	virtual bool Execute( );		// sJn
//	void AppendExtension();
};

#endif	__COMFILE_H
