#ifndef	__FILENAME_H
#define	__FILENAME_H

#ifndef __CHAR_H
#include "char.h"
#endif

#ifndef __TNDEFS_H
#include "tndefs.h"
#endif

class Filename : TNChar {
	public:
		Filename( const tchar *str );
		Filename();
//		void set( const tchar *str );
		void changeFile( const tchar *str );
		void changePath( const tchar *str );
		void changeExt( const tchar *str );
		void getPath( tchar *buf );
		void getFile( tchar *buf );
		void getExt( tchar *buf );
		void normalize( );					// ΃pX΃pX֕ϊ
};

void addyen(tchar *path);
tchar *getbasename( const tchar *str );
tchar *getextname( const tchar *str );
BOOL makefilename( TNChar &fullpath, const tchar *path, const tchar *filename );

#define	PSF_WILDCARD	0x0001	// ChJ[h(*?)
#define	PSF_DIRECTORY	0x0002	// \}[N܂܂Ă
#define	PSF_DRIVE		0x0004	// hCu}[N : 
#define	PSF_NETWORK		0x0008	// 擪\\}[N
#define	PSF_EXTENSION	0x0010	// gq.}[N(gq邩ǂ͂킩Ȃj
#define	PSF_ILLEGAL		0x1000	// sȕ
int parsefilename( const tchar *filename );	// t@C̉
											// ߂lPSF_...

// t@CpNX
class FindFile {
	protected:
		TNChar path;
		BOOL fFirst;
#ifdef WINCE
		HANDLE hFind;
#endif
	public:
		int flag;
#if defined(__TURBOC__) && !defined(WINCE)
		_tffblk ffb;
#endif
	public:
		FindFile( const tchar *path, int attr );
		~FindFile();
		BOOL Find( TNChar &filename );
};

// 
#if 0
class FindFile32 {
};
#endif

#endif	// __FILENAME_H
