#include "tndefs.h"
#include "filestr.h"

#include <windows.h>	// WindowsR[h邽ߎb[u

// patht@C̐擪̃AhX𓾂
tchar *GetFileNamePtr( const tchar *path )
{
	if (!path)
		return NULL;

	const tchar *p;
	const tchar *delim1 = NULL;
	const tchar *delim2 = NULL;

	for ( p=path; *p ; ){
		tchar c = *p;
		if ( c=='\\' || c=='/'){
			delim1 = ++p;
		} else if ( c == ':' ){
			delim2 = ++p;
		} else {
			p = CharNext(p);
		}
	}

	return (tchar*)( delim1 ? delim1 : ( delim2 ? delim2 : path ) );
}

const tchar *GetFileExtPtr(const tchar *filename)
{
	if (!filename)
		return NULL;

	const tchar *ext = NULL;
	while ( *filename ){
		if ( *filename == '.' ){
			ext = filename+1;
		} else if ( *filename == '\\' || *filename=='/'){
			ext = NULL;
		}
		CharNext( filename );
	}
	return (tchar*)ext;
}
