#ifndef	__STR_H
#define	__STR_H

#include	"tnstr.h"

char *ubtospc(char *str);

class Str {
private:
	int maxlen;				//݂̂Ƃ떳Ӗ
protected:
	char *buf;
public:
	Str(int _maxlen);
	~Str();
	void set(const char *str);
	int len( void );
	char &operator [](int c)	{return buf[c];}
	operator const char *()			{return buf;}
};

class Path : public Str {
	char *fullpath;				//tpX̃obt@
								//make()܂ŐĂ
public:
	Path();
	~Path();
	const char *make(const char *filename);		//tpX쐬
};

//char *Char^ɂāA񒷂ɑ΂鏈Kv
void addmd(char *filename);
char *strgetfile(char *buf, const char *str);
char *makeuniqname(char *filename);
int checkext(const char *filename);
int getnum(int &num, const char *&str);
char *getstrword( const char *buf, tnstr &word );			//pP̎擾
char *getstrnumword( const char *buf, tnstr &word );			//pŎn܂p̎擾

// VK 1995.12.29
// Xy[XƂ͔pXy[Xƃ^u
//tchar *SkipSpc( const tchar *str );	// strɃXy[X΃XLbv
//tchar *SkipChar( const tchar *str );
//tchar *SkipNum( const tchar *str );	// l̂݃XLbv(擪+/-F)
tchar *SkipTo( const tchar *str, int c );	// c̕܂ŃXLbv(|C^[cցAcꍇ͏I['\0')

//#define	LD_CHAR(c, p)	{c = (uchar)*p++; if(iskanji(c)) c = ((ushort)c << 8) + (uchar)*p++;}
//#define	ST_CHAR(c, p)	{if ((ushort)c > 0x100) *(uchar*)p++ = c >> 8; *(uchar*)p++ = c;}

#endif	// __STR_H
