#ifndef	__TNWINX_H
#define	__TNWINX_H

#include "tndefs.h"

void InitTNWinLib( HINSTANCE hInstance );
void FinishTNWinLib();
	
// ֐

#define	LPSTRC	(LPSTR)(const char *)

void MoveCenter( RECT &r );

#include "getstr.h"
#include "tnstr.h"

// LoadString()֗̕
// ԂlNULL̂Ƃ̓G[
// 256܂('\0'܂߂āj
// ɌĂŗǂ񐔂͂S܂
// InitTNWinLib()ĂԂƁII

extern HINSTANCE hTNInstance;

tnstr GetWindowTextStr( HWND hwnd );

void _cdecl EnableItemWindows( HWND hwnd, BOOL f, ... );
void _cdecl _EnableItemWindows( HWND hwnd, BOOL f, ... );
void EnableItemWindows( HWND hwnd, BOOL f, int *ids );
void _cdecl ShowItemWindows( HWND hwnd, BOOL f, ... );
void _cdecl _ShowItemWindows( HWND hwnd, BOOL f, ... );
void ShowItemWindows( HWND hwnd, BOOL f, int *ids );

#ifndef EXCLUDE_DBW
void DBW( const char *format, ... );
void D8( const void *data, int len );
void D16( const void *data, int len );
void D32( const void *data, int len );
#else
inline void DBW( const char *, ... ){}
inline void D8( const void *, int  ){}
inline void D16( const void *, int ){}
inline void D32( const void *, int ){}
inline void DFIN( const char * ){}
inline void DFOUT( const char * ){}
#endif

#define	dbw	DBW

#ifdef	__cplusplus
extern "C" {
#endif
void    FAR _cdecl DEBUGOUTPUT(UINT flags, LPCSTR lpsz, ...);
#ifdef	__cplusplus
};
#endif



#ifdef WIN32
inline BOOL IsValidInstance( HINSTANCE hInst )
{
	return hInst != NULL;
}
#else
inline BOOL IsValidInstance( HINSTANCE hInst )
{
	return hInst >= HINSTANCE_ERROR;
}
#endif

#ifndef WINCE
inline HWND GetWindow_HWNDPARENT( HWND hwnd )
{
#if defined(WIN32)
	return (HWND)::GetWindowLong( hwnd, GWL_HWNDPARENT );
#else
	return (HWND)::GetWindowWord( hwnd, GWW_HWNDPARENT );
#endif
}

#if defined(WIN32)
// Win32ł͂܂ȂH->߂
#else
inline HINSTANCE GetWindow_HINSTANCE( HWND hwnd )
{
	return (HINSTANCE)::GetWindowWord( hwnd, GWW_HINSTANCE );
}
#endif
#endif	// !WINCE

inline UINT GetWindow_ID( HWND hwnd )
{
#if defined(WIN32)
	return GetWindowLong( hwnd, GWL_ID );
#else
	return GetWindowWord( hwnd, GWW_ID );
#endif
}

#ifndef WINCE
inline HBRUSH GetClass_HBRBACKGROUND( HWND hwnd )
{
#if defined(WIN32)
	return (HBRUSH)::GetClassLong( hwnd, GCL_HBRBACKGROUND );
#else
	return (HBRUSH)::GetClassWord( hwnd, GCW_HBRBACKGROUND );
#endif
}

inline void SetClass_HBRBACKGROUND( HWND hwnd, HBRUSH hbr )
{
#if defined(WIN32)
	::SetClassLong( hwnd, GCL_HBRBACKGROUND, (LONG)hbr );
#else
	::SetClassWord( hwnd, GCW_HBRBACKGROUND, (WORD)hbr );
#endif
}
#endif	// !WINCE


void IMEOpen( HWND hwnd, BOOL f );
BOOL IsIMEOpened( HWND hwnd );

HWND GetPreviousInstanceWindow( HINSTANCE hPrev );	// ɋNĂCX^X̃EBhEԂ

void Hourglass( BOOL bOn );
void ResetHourglass( );

#if defined(WIN32) && !defined(WINCE)
inline void MoveTo( HDC hdc, int x, int y )
{
	::MoveToEx( hdc, x, y, NULL );
}
#endif

// in TNWIN6.CPP
bool GetTemporaryFileName( const tchar *prefix, tnstr &filepath );	// Ɨpt@C̍쐬

// in TNWIN7.CPP
void LoadInitWindow( HWND hwnd, RECT &rcProf, UINT &showProf );
void SaveInitWindow( HWND hwnd, RECT &rcProf, UINT &showProf );

#if defined(WINCE) && defined(SUPPORT_LANG)
typedef int (WINAPI *FNWideCharToMultiByte)( UINT, DWORD, LPCWSTR, int, LPSTR, int, LPCSTR, LPBOOL );
typedef int (WINAPI *FNMultiByteToWideChar)( UINT, DWORD, LPCSTR, int, LPWSTR, int );
extern FNWideCharToMultiByte _WideCharToMultiByte;
extern FNMultiByteToWideChar _MultiByteToWideChar;
#else
#define	_WideCharToMultiByte	WideCharToMultiByte
#define	_MultiByteToWideChar	MultiByteToWideChar
#endif

#endif	__TNWINX_H
