#ifndef	__JRECTRL_H
#define	__JRECTRL_H

#include	"rexpgen.h"

#include	"jreusr.h"
#include "jrefuzzy.h"

typedef BOOL (WINAPI *LPFUZZY_OPEN)( JREFUZZYDATA* pData, BOOL fDummy);
typedef BOOL (WINAPI *LPFUZZY_CLOSE)( JREFUZZYDATA* pData );
typedef BOOL (_cdecl *LPFUZZY_OPTIONDIALOG)( HWND hwndParent, UINT flagsDisable );
typedef JREFUZZYDATA* (WINAPI *LPFUZZY_GETFUZZYDATAINJRE)( JRE2* pJre );



//	JREObject̃CX^X͕݂Ă\ȂiHHJRE.DLLőΉĂ邩ǂł邪j
//	̃IuWFNg͂ȂׂZǂiJRE.DLL̎dlɂHj

class JREObject : public GenericRexp {
typedef GenericRexp super;
protected:
	static HINSTANCE hinstJRE;		// JRECX^Xnh
	static int nInstance;			// ̃IuWFNg̃CX^XJE^[
	static LPJRE2OPEN lpfnJre2Open;
	static LPJRE2CLOSE lpfnJre2Close;
	static LPJRE2GETMATCHINFO lpfnJre2GetMatchInfo;
	static LPJRE2COMPILE lpfnJre2Compile;
	static LPFUZZY_OPTIONDIALOG lpfnFuzzy_OptionDialog;
	static LPFUZZY_GETFUZZYDATAINJRE lpfnFuzzy_GetFuzzyDataInJre;
	static bOpened;
public:
	JRE2 jre2;						// JRE\
	int error;
	static const tchar *DllName;			// JRE dll filename
public:
	JREObject( );
	~JREObject( );

	WORD GetVersion( );

	// KOpen-Closȇ΂Ŏgp鎖
	BOOL Open( );
	void Close( );
	virtual BOOL CanUse( )
		{ return hinstJRE != NULL; }

	BOOL SubOpen( );
	void SubClose( );
	virtual BOOL CompileImpl( const tchar *patern );

	virtual BOOL CompareImpl( const tchar *str );

	virtual int GetErrorCode( );

	// Jnʒuwɂr
	// Ă񂾌ACompare( const tchar *str )Ăԏꍇ
	// jre2.nStart 0ɂȂ΂ȂȂiǕKvj
	BOOL Compare( const tchar *str, int startpos );
	virtual BOOL Compare( const tchar *str, TMatchInfos *matches=NULL )
		{ return super::Compare(str, matches); }
	

	BOOL GetMatchImpl( int &len, int &loc );	// len : }b` loc : }b`ʒu

	void UseFuzzy( BOOL f )
	{
		SetFlag( GRXP_FUZZY, f );
	}
	void OptionDialog(HWND parent);
protected:
	void SetupIgnoreCase();
};

#endif	__JRECTRL_H
