#ifndef	__QUE_H
#define	__QUE_H

//̃NX̓IuWFNgLȂƌ͉̂R
//pop(),get()IuWFNgj󂳂Ȃ
//c̃IuWFNg͌̃NX̃IuWFNgj󂳂ƂɑSĔj󂳂
//܂AL[obt@zꍇAÂIuWFNj󂳂
template <class T>
class ObjectQueT {
	protected:
		const T **que;
		int num;
		int putp;
		int getp;
		int size;
	public:
		ObjectQueT( int _size );
		virtual ~ObjectQueT();
		void put( const T *obj );
		T *get( void );
		void clear( void );
		//ȑ(X^bNƓlɈ)
		T *pop( void );
		int get_num( void )	{return num;}
};

template <class T>
ObjectQueT<T>::ObjectQueT( int _size )
{
	size = _size;
	putp = 0;
	getp = 0;
//	que = (T**)malloc( sizeof( T* ) * size );
	que = new T*[ size ];
	que[0] = 0;
}

template <class T>
ObjectQueT<T>::~ObjectQueT()
{
	clear();
	delete (T**)que;
}

template <class T>
void ObjectQueT<T>::clear( void )
{
	while ( putp != getp ){
		delete get();
	}
}

template <class T>
void ObjectQueT<T>::put( const T *obj )
{
	if ( num >= size ){
		delete get();
	}
	que[putp++] = obj;
	num++;
	if ( putp >= size ){
		putp = 0;
	}
}

template <class T>
T *ObjectQueT<T>::get( void )
{
	if ( num == 0 ){
		return 0;
	}
	T *t = (T*)que[getp++];
	num--;
	if ( getp >= size ){
		getp = 0;
	}
	return t;
}

template <class T>
T *ObjectQueT<T>::pop( void )
{
	if ( num == 0 ){
		return 0;
	}
	if ( putp == 0 ){
		putp = size;
	}
	num--;
	return (T*)que[--putp];
}

class ObjectQueBase {
	protected:
		void **que;
		int num;
		int putp;
		int getp;
		int size;
	protected:
		virtual void delete_object( void *obj ) = 0;
	public:
		ObjectQueBase( int _size );
		virtual ~ObjectQueBase();
		void put( void *obj );
		void *get( void );
		void clear( void );
		//ȑ(X^bNƓlɈ)
		void *pop( void );
		int get_num( void )	{return num;}
		int is_full( )
			{ return num == size; }
};


template <class T>
class ObjectQue : public ObjectQueBase {
	protected:
		virtual void delete_object( void *obj );
	public:
		ObjectQue( int size )
			:ObjectQueBase( size ){}
		~ObjectQue();
};

template <class T>
void ObjectQue<T>::delete_object( void *obj )
{
	delete ( T* )obj;
}

template <class T>
ObjectQue<T>::~ObjectQue( )
{
	clear( );
	if ( que ){
		delete que;
		que = 0;
	}
}

#endif	// __QUE_H
