#ifndef	__TNDEFS_H
#define	__TNDEFS_H

// WinCE֘A //
#ifdef _WIN32_WCE
#ifndef WINCE
#define	WINCE
#endif
#ifndef _Windows
#define	_Windows
#endif
#endif

#if defined(_Windows) || defined(_WINDOWS)

#include <tchar.h>

#if defined(WIN32_PLATFORM_HPC2000)
// H/PC 2000
#define	WINHPC
#elif defined(WIN32_PLATFORM_HPCPRO)
// H/PC Pro
#define	WINHPC
#elif defined(WIN32_PLATFORM_PSPC)
// Pocket PC
#ifndef WINPPC
#define	WINPPC
#endif
#if (WIN32_PLATFORM_PSPC == 1)
// Pocket PC 2000
#ifndef PKTPC
#define	PKTPC
#endif
#elif (WIN32_PLATFORM_PSPC >= 310)
// Pocket PC 2002
#define	PKTPC
#else
// Some other Pocket PC
#endif
#elif defined(WIN32_PLATFORM_WFSP)
// Smartphone
#error	not supported
#else
// etc.
#endif

#ifdef _MSC_VER
#define DllImport	__declspec( dllimport )
#define DllExport	__declspec( dllexport )
#ifndef __WIN32__
#  define	__WIN32__
#endif
#endif
#ifdef __TURBOC__
#define DllImport	_import
#define DllExport	_export
#endif

#ifndef _Windows
#define _Windows
#endif

#ifndef _WINDOWS
#define	_WINDOWS
#endif

#ifndef STRICT
#define	STRICT
#endif

#if defined(__WIN32__) || defined(_WIN32)
#  ifndef WIN32
#    define	WIN32
#  endif
#else
#define	WIN16
#endif

#endif	// defined(_Windows) || defined(_WINDOWS)

// e탂fpdefine
#ifdef __EWL
#define	_WINDOWS
#define	WIN16
#define	STRICT
#define	WIN31
#define	NOUSEOWL
#endif

#ifdef OWL2
#define	_WINDOWS
#define	STRICT
#define	WIN31
#endif

#if defined(WIN16) && ( defined(__SMALL__) || defined(__MEDIUM__) )
#define	WIN16NP			// ftHg̃|C^[LPقȂ
#endif

#define	TYPEDEF_UCHAR

typedef unsigned char byte;
typedef	unsigned char uchar;
typedef unsigned short ushort;
typedef unsigned int uint;
typedef unsigned long ulong;
typedef unsigned char boolean;

#ifdef UNIX
#define	STR_DIRSEP	"/"
#define	CHR_DIRSEP	'/'
#else
#define	STR_DIRSEP	"\\"
#define	CHR_DIRSEP	'\\'
#endif

#if defined(UNIX) && !defined(UNIX64)
#define	__int64		long long int
#endif

// Windows݊̐錾(I) ////////////////////////////////////////////////

#if defined(UNIX)
#define	_mbsnicmp	strnicmp
#define	_mbsicmp	stricmp
//#define	_mbsrchr(s,c)	strrchr((const char*)s, c)
//#define	_mbschr(s,c)	strchr((const char*)s, c)
#define	_mbstok		strtok
#define	_mbslen		strlen
#endif

#ifndef _Windows
#define	_tcslen		strlen
#define	_tcscpy		strcpy
#define	_tcscat		strcat
#define	_tcsncpy	strncpy
#define	_tcscmp		strcmp
#define	_tcschr		strchr
#define	_tcsstr		strstr
#define	_tcsicmp	stricmp
#define	_tcsnicmp	strnicmp
#define	_totupper	toupper
#define	_totlower	tolower
#define	_itot		itoa
#define	_tfullpath	_fullpath
#endif

// UNICODE݊̐錾 ////////////////////////////////////////////////

#define	IS_UNICODE_MARK(c)	((c)==0xFEFF || (c)==0xFFFE)

#if defined(_UNICODE)
#ifdef __UTF8
typedef char tchar;
typedef unsigned char tuchar;
//#define	_TW(str)	((unsigned short)(_T(str)[0]))		// QoCg(ushort)
#define	_t(x)		x
#else	// UTF-16
typedef wchar_t tchar;
typedef tchar tuchar;
#define	_TW(str)	((unsigned short)(_T(str)[0]))		// QoCg(ushort)
#define	_t		_T
#endif
#else	// !UNICODE
typedef char tchar;
typedef unsigned char tuchar;
#ifndef _T
#define	_T(x)	(x)
#endif
#define	_t(x)	x
#define	_TW(str)	(((unsigned short*)_T(str))[0])		// QoCg(ushort)
#endif

// {̃̕oCgPʂ̒(Ō'\0'܂܂Ȃ)
#define	_tcsbyte(x)		LENTOBYTE(_tcslen(x))
// {̃̕oCgPʂ̒(Ō'\0'܂
#define	_tcsbyte1(x)	(_tcsbyte(x)+sizeof(tchar))
#define	_tcslen1(x)		(_tcslen(x)+1)

#ifdef _UNICODE
#define	_tmbsnicmp		_tcsnicmp
#define	_tmbsicmp		_tcsicmp
#define	_tmbsrchr		_tcschr
#define	_tmbschr		_tcschr
#define	_tmbstok		_tcstok
#define	_tmbslen		_tcslen
#else
#define	_tmbsnicmp		_mbsnicmp
#define	_tmbsicmp		_mbsicmp
#define	_tmbsrchr		_mbsrchr
#define	_tmbschr		_mbschr
#define	_tmbstok		_mbstok
#define	_tmbslen		_mbslen
#endif

// UNICODE, UTF8, ANSIŋʂȃ}N
#if defined(_UNICODE) && defined(__UTF8)
#define	__tcslen		strlen
#define	__tcscpy		strcpy
#define	__tcscmp		strcmp
#define	__tcsstr		strstr
#define	__tcstok		strtok
#define	__ttoi			atoi
#else
#define	__tcslen		_tcslen
#define	__tcscpy		_tcscpy
#define	__tcscmp		_tcscmp
#define	__tcsstr		_tcsstr
#define	__tcstok		_tcstok
#define	__ttoi			_ttoi
#endif

#define	AnsiToUnicode( str1, str2, tsize2 )		MultiByteToWideChar( CP_ACP, 0, str1, -1, str2, tsize2 )
#define	UnicodeToAnsi( str1, str2, tsize2 )		WideCharToMultiByte( CP_ACP, 0, str1, -1, str2, tsize2, NULL, NULL )

// temporary until STCHAR/tcharɑΉ܂ //
#define	LENTOBYTE		_TLENTOBYTE
#define	BYTETOLEN		_TBYTETOLEN

#ifdef _UNICODE
#define	_TBYTETOLEN(x)	((x)>>1)	// for TCHAR
#define	_TLENTOBYTE(x)	((x)<<1)
#ifdef __UTF8
#define	_tBYTETOLEN(x)	(x)			// for tchar
#define	_tLENTOBYTE(x)	(x)
#else
#define	_tBYTETOLEN(x)	((x)>>1)
#define	_tLENTOBYTE(x)	((x)<<1)
#endif
#else
#define	_TBYTETOLEN(x)	(x)			// for TCHAR
#define	_TLENTOBYTE(x)	(x)
#define	_tBYTETOLEN(x)	(x)			// for tchar
#define	_tLENTOBYTE(x)	(x)
#endif

#define	UNICODE_BYTEORDER	0xfeff

#define	tsizeof(type)	BYTETOLEN(sizeof(type))

#if !defined(DOS)
#define	FP_DIFF( p1, p2 )	( (uint)( (char*)(p1) - (char*)(p2) ) )
#define	STR_DIFF( p1, p2 )	( (uint)( (tchar*)(p1) - (tchar*)(p2) ) )
#else
#define	FP_DIFF( p1, p2 )	( FP_OFF( p1 ) - FP_OFF( p2 ) )
#endif


// 񏈗
#if defined(__UTF8)
#include "utf.h"
inline char *NEXT_CHAR( const char *str ){ return (char*)utf8CharNext(str); }

#elif	defined(ANSI)
inline char *NEXT_CHAR( const char *str ){ return (char*)str+1; }	// R[h́HHHHHHHH
#else	/* !ANSI */
#  ifdef _Windows
#    ifdef WIN32
#      define	NEXT_CHAR( s )	CharNext( s )
#    else
#      define	NEXT_CHAR( s )	AnsiNext( s )
#    endif
#  else	/* !_Windows */
#ifndef UNIX
#      include <mbctype.h>
#endif	/* !UNIX */
inline char *NEXT_CHAR( const char *str ){ if ( _ismbblead( *str ) ) return (char*)str+2; else return (char*)str+1; }
#  endif	/* !_Windows */
#endif		/* !ANSI */

#define	Bit2Bool( fVal, bit )	( ( fVal & bit ) == bit )
#define	Bool2Bit( bVal, bit )	( bVal ? bit : 0 ) 

#define	_delete( obj )	delete obj; obj = 0
#define	__delete( obj )	if ( obj ){ delete obj; obj=0; }

// WinCȆ֏
#ifdef WINCE
#define	InvertRect( hdc, rc )		PatBlt( hdc, (rc)->left, (rc)->top, (rc)->right, (rc)->bottom, DSTINVERT )
#define	TPM_RIGHTBUTTON				0
#endif

#endif	// __TNDEFS_H

