#
#
#
#
#
#	PROG	: K{
#	OBJ		: K{
#	OBJPATH	:
#	SRC		: K{
#
#
#	OWL2
#	OWL18
#
#	TNLIB	:
#
#	CMD		: R}hvvg
#	DLL		: .DLL
#
#	USEDLL	: USE DLLs
#
#	RTTI	:
#	EXCPT	:
#
#	WILDARGS : R}hC̃ChJ[hWJ
#
#	RCOPT	: brcc option

!if !$d(MAK)
MAK = $(PROG).mak
!endif

!if !$d(PERL)
!if "$(OS)"=="Windows_NT"
PERL = perl
!else
PERL = jperl
!endif
!endif
BRC32 = Brc32

!if !$d(BCCPATH)
!if $(CBUILDER)==1
BCCPATH = k:\Borland\cbuilder5\\
!else
BCCPATH = d:\bc4\\
!endif
!endif

!if !$d(BCC32)
BCC32 = $(BCCPATH)bin\Bcc32
!endif
!if !$d(TLINK32)
!if $(CBUILDER)==1
TLINK32 = $(BCCPATH)BIN\iLink32
!else
TLINK32 = TLink32
!endif
!endif
TNOBJDIR = o32
!if !$d(TNLIBP)
TNLIBP = \src\tnlib2\\
!endif

OWL18P = $(BCCPATH)include\owl18\o32\\

COPT = $(COPT) -DSTRICT

!if $(ALLINCLUDE) == 0
COPT = $(COPT) -DWIN32_LEAN_AND_MEAN
!endif

############# start of CMD ################
!if $(CMD) == 1

COPT = $(COPT) -DNOUSEOWL;CMD

!if $(DLL) == 1
TNOBJDIR = $(TNOBJDIR)cd
COPT = $(COPT) -WCD
IOBJ =$(BCCPATH)lib\c0d32.obj
LNKOPT = /Tpd /ap $(LNKOPT)
!else
TNOBJDIR = $(TNOBJDIR)c
COPT = $(COPT) -WC
IOBJ =$(BCCPATH)lib\c0x32.obj
LNKOPT = /Tpe /ap $(LNKOPT)
!endif

############# else CMD ################
!else

!if $(OWL18) == 1
OWL = 1
LIB = $(LIB) $(OWL18P)owl18.lib
DEFINE = $(DEFINE);OWL18;USE_ALIAS
!endif

!if $(OWL2) == 1
OWL = 1
DEFINE = $(DEFINE);OWL2;USE_ALIAS
TNOBJDIR = $(TNOBJDIR)2
!endif

!if $(DLL) == 1
TNOBJDIR = $(TNOBJDIR)d
COPT = $(COPT) -WD
IOBJ =$(BCCPATH)lib\c0d32.obj
LNKOPT = /Tpd -aa $(LNKOPT)
!else
COPT = $(COPT) -W
IOBJ =$(BCCPATH)lib\c0w32.obj
LNKOPT = /Tpe -aa $(LNKOPT)
!endif

!endif
############## end of CMD #####################

!if $(WILDARGS) == 1
EXTOBJ = $(BCCPATH)lib\32bit\wildargs.obj
!endif

!if $(TNLIB) == 1
LIB = $(LIB) $(TNLIBP)$(TNOBJDIR)\tnclass.lib
LIBP = $(LIBP);$(TNLIBP)
INC = $(INC);$(TNLIBP)
!endif

!if $(RTTI) == 1
COPT = $(COPT) -RT
!else
COPT = $(COPT) -RT-
!endif

!if $(EXCPT) == 1
!else
COPT = $(COPT) -x-
#OBJ = $(BCCPATH)lib\NOEHxx.obj $(OBJ)
!endif

!if $d(OBJPATH)
.PATH.obj = $(OBJPATH)
.PATH.cpp = $(SRC)
.PATH.c = $(SRC)
OPT = $(OPT) -n$(OBJPATH)
!endif

LIB = $(LIB) import32.lib
!if $(CBUILDER)==1
#LIB = $(LIB) cw32mt.lib
LIB = $(LIB) cw32.lib
!else
LIB = $(LIB) cw32.lib
!endif
LIBP = $(LIBP);$(BCCPATH)lib
INC = $(INC);$(BCCPATH)include

COPT = $(COPT) $(OPT)
!if $d(DEFINE)
COPT = $(COPT) -D$(DEFINE)
!endif
LNKOPT = -m -c -n -L$(LIBP) $(LNKOPT)

!if !$d(RCFILE)
RCFILE = $(PROG).res
!endif

!if $d(OBJPATH)
$(PROG).exe : $(PROG).cfg $(RCFILE) $(OBJ)
	@echo LIB=$(LIB)
	@$(PERL) -n -e "$$s='$(OBJPATH)'; s/(\S+)/$$s\\$1/g; print;" &&|
$(OBJ) $(EXTOBJ)
| > $(PROG).__1
	@copy &&|
$(LNKOPT) $(IOBJ)+
|+$(PROG).__1+&&|
$<,$*.map
$(LIB)
$(DEF)
$(RCFILE) $(RESFILE)
| $(PROG).__2 >nul
	@del $(PROG).__1
	$(TLINK32) @$(PROG).__2
#	del $(PROG).__2

!else
$(PROG).exe : $(PROG).cfg $(RCFILE) $(OBJ)
	$(TLINK32) @&&|
$(LNKOPT) +$(IOBJ) $(OBJ) $(EXTOBJ)
$<,$*.map
$(LIB)
$(DEF)
$(RCFILE) $(RESFILE)
|
!endif

.rc.res :
	$(BRC32) -w32 -I$(BCCPATH)include -R -FO$@ $(RCOPT) $.

.cpp.obj :
	$(BCC32) -c @$(PROG).cfg {$. }

.c.obj :
	$(BCC32) -c @$(PROG).cfg {$. }

$(PROG).cfg : $(MAK)
	@echo TNOBJDIR=$(TNOBJDIR)
	@copy &&|
-w
-R-
-I$(SRC);$(INC)
-L$(SRC);$(LIBP)
-H=$(TEMP)\$(PROG).csm
$(COPT)
| $(PROG).cfg >nul
