#ifndef __WINWAV_H
#define	__WINWAV_H

#define	MME_OPEN		1	// I[vG[
#define	MME_NOTWAVE		2	// wavet@CłȂ
#define	MME_FORMATERROR 3	// wavetH[}bgG[
#define	MME_NODATA		4	// f[^͂Ȃ
#define	MME_READ		5	// ǂݍ݃G[
#define	MME_WRITE		6	// ݃G[
#define	MME_MEMORY		7	// s

#ifndef __MMSYSTEM_H
#include <mmsystem.h>
#endif

#ifdef WIN32
#else
typedef UINT MMRESULT;
#endif

class WaveIO {
	public:
		HMMIO hmmio;
		int error;
		PCMWAVEFORMAT pcm;
		DWORD datalength;
		BOOL fWriting;		// f[^ݒ
	protected:
		// ݗpf[^
		MMCKINFO *mminfo1;	// RIFF`N
		MMCKINFO *mminfo2;    // Sub`N
	public:
		WaveIO( );
		~WaveIO( );
		// ǂݍݗp(file I/O)
		BOOL Open( const tchar *filename, FOURCC fccHeader=NULL );
		BOOL BufferdOpen( const tchar *filename, FOURCC fccHeader=NULL );
		// ǂݍݗp(memory file)
		BOOL MemoryOpen( const tchar *buffer, long length, FOURCC fccHeader=NULL );
	protected:
    	BOOL OpenCom( FOURCC fccHeader );
	public:

		LRESULT Read( HPSTR buf, long maxlen )
			{ return mmioRead( hmmio, buf, maxlen ); }
		LRESULT Seek( LONG offset, int direction )
			{ return mmioSeek( hmmio, offset, direction ); }
		DWORD GetLength( )
			{ return datalength; }
		// ݗp
		// ӁFCreate()ĂԑOɁAoϐpcm𐳂ZbgĂI
		BOOL Create( const tchar *filename, long datalength, FOURCC fccHeader=NULL );
		// buffer,length͍ŏ̃TCYł\Ȃ
		// bufferGlobalAlloĉł邱
		BOOL MemoryCreate( byte *buffer, DWORD length, FOURCC fccHeader=NULL );
		BOOL CreateCom( DWORD length, FOURCC fccHeader );
		LRESULT Write( HPSTR buf, LONG len )
			{ return mmioWrite( hmmio, (HPSTR)buf, len ); }
			// ӁFCreate()Ŏw肵datalengthWrite()ŏ񂾃f[^̍v͈v鎖I(?)
		// 
		void Close( );
		int GetError( )
			{ return error; }
	protected:
		// WindowsmmioXXXX֐Q̃JvZ	///////////////////////////////
		HMMIO MOpen( const tchar *filename )
			{ return mmioOpen( (LPTSTR)filename, NULL, MMIO_READ ); }
		HMMIO MOpen( const tchar *filename, DWORD flags )
			{ return mmioOpen( (LPTSTR)filename, NULL, MMIO_READ | flags ); }
		HMMIO MCreate( const tchar *filename )
			{ return mmioOpen( (LPTSTR)filename, NULL, MMIO_CREATE|MMIO_READWRITE ); }
		HMMIO MCreate( const tchar *filename, DWORD flags )
			{ return mmioOpen( (LPTSTR)filename, NULL, MMIO_CREATE|MMIO_READWRITE | flags ); }
		LRESULT MWrite( void *buf, LONG len )
			{ return mmioWrite( hmmio, (const char*)buf, len ); }
		MMRESULT Descend( LPMMCKINFO mmck1, LPMMCKINFO mmck2, UINT flag )
			{ return mmioDescend( hmmio, mmck1, mmck2, flag ); }
		MMRESULT Ascend( LPMMCKINFO mmck )
			{ return mmioAscend( hmmio, mmck, 0 ); }
		MMRESULT CreateChunk( LPMMCKINFO mmck, UINT option )
			{ return mmioCreateChunk( hmmio, mmck, option ); }

		// Zq
	public:
		operator PCMWAVEFORMAT &()
			{ return this->pcm; } 
};
#endif	__WINWAV_H
